;;;Bosse-engineering                                                                                       
;;;Dipl.-Ing. Jrn Bosse                                                                                   
;;;Am Klei 5	                                                                                           
;;;384458 Velpke                                                                                           
;;;Tel. 05361 / 989 677                                                                                    
;;;mobil. 0176 / 232 828 51                                                                                
;;;bosse@bosse-engineering.com                                                                             
;;;                                                                                                        
;;;--------------------------------------------------------------------------------------------------------
;;;WorkShop "LISP-Programmierung" 18.11.09								   
;;;--------------------------------------------------------------------------------------------------------


;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Hauptfunktion c:BaumEinfuege => Beispiel Baum einfgen              		   
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

(defun c:BaumEinfuege ( / AWS N TEXTWERT ART KRONE PKT STAMM)
  (setvar "ATTREQ" 0)
  (setvar "CMDECHO" 0)
  (if (not JB_$$_stamm)(setq JB_$$_stamm 0.1))
  (if (not JB_$$_krone)(setq JB_$$_krone 12.0))
  (if (not JB_$$_art)(setq JB_$$_art "Ei"))
  (while (and(setq pkt (getpoint "\nEinfgepunkt fr Baum (ENTER=ENDE):"))
             (or(and
                  (setq stamm(getreal (strcat "\nStammdurchesser[m]:<"(rtos JB_$$_stamm 2 2)">")))
                  (setq JB_$$_stamm stamm))
                (setq stamm JB_$$_stamm))
             (or(and
                  (setq krone(getreal (strcat "\nKronendurchesser[m]:<"(rtos JB_$$_krone 2 1)">")))
                  (setq JB_$$_krone krone))
                (setq krone JB_$$_krone))
             (or(and
                  (/=(setq art(getstring (strcat "\nBaumart:<" JB_$$_art ">")))"")
                  (setq JB_$$_art art))
                (setq art JB_$$_art))
             )
    (BaumEinfuege:insert "BBMKR" "BT-BM-SYM" 'T art stamm krone pkt)
    (BaumEinfuege:insert "BBMST" "BT-BM-SYM" nil art stamm krone pkt))
  (princ "\Ende.")
  (princ))

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Funktion BaumEinfuege:insert => Baumblock einfgen                              
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;;;-> blockname: Blockname als String
;;;-> einflayer: Einfgelayer
;;;-> flag: wenn 'T, dann Baumkrone
;;;-> art: Baumart als String
;;;-> stamm: Stammdurchmesser als REAL
;;;-> krone: Kronendurchmesser als REAL
;;;-> pkt: x,y,z als REAL

(defun BaumEinfuege:insert (baumart einflayer flag art stamm krone pkt / ATT_LISTE)    
    (command "_.insert" baumart pkt (if flag krone stamm) (if flag krone stamm) 0.0)
    (entmod(subst (cons 8 einflayer)(assoc 8 (entget(entlast)))(entget(entlast))))
    (setq att_liste (cadr (car(JBf_WorkShop:Block:Attliste:get (entlast))))
          att_liste (subst(cons 10
                                (polar pkt
                                       (angle pkt (cdr(assoc 10 att_liste)))
                                       (+ (/(if flag krone stamm)2.0)
                                          (* (/
                                               (distance pkt (cdr(assoc 10 att_liste)))
                                               (if flag krone stamm))
                                             0.25))))
                          (assoc 10 att_liste)att_liste)         
          att_liste (subst (cons 40 0.625)(assoc 40 att_liste)att_liste)
          att_liste (subst (cons 1 (strcat art " %% " (rtos stamm 2 2) " - " (rtos krone 2 1)))
                           (assoc 1 att_liste)att_liste))
    (entmod att_liste)
    (entupd (entlast)))

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Funktion JBf_WorkShop:Block:Attliste:get =>Attributsliste aus Blockobjekt       
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;;;-> elem: Element vom Typ Block
;;;<- list_att: Gruppencodeliste Attribute aus Block

(defun JBf_WorkShop:Block:Attliste:get (elem / list_att)
  (if (and (entnext elem)(=(cdr(assoc 0(entget (entnext elem))))"ATTRIB"))
    (while (and(setq elem (entnext elem))
	       (/= "SEQEND" (cdr(assoc 0(entget elem)))))
      (if (=(cdr(assoc 0(entget elem)))"ATTRIB")
	(setq list_att (cons (list (cdr(assoc 2 (entget elem)))(entget elem))list_att)))))
  (reverse list_att))
           
  
